Blame tests/cert-tests/inhibit-anypolicy

Packit aea12f
#!/bin/sh
Packit aea12f
Packit aea12f
# Copyright (C) 2017 Red Hat, Inc.
Packit aea12f
#
Packit aea12f
# This file is part of GnuTLS.
Packit aea12f
#
Packit aea12f
# GnuTLS is free software; you can redistribute it and/or modify it
Packit aea12f
# under the terms of the GNU General Public License as published by the
Packit aea12f
# Free Software Foundation; either version 3 of the License, or (at
Packit aea12f
# your option) any later version.
Packit aea12f
#
Packit aea12f
# GnuTLS is distributed in the hope that it will be useful, but
Packit aea12f
# WITHOUT ANY WARRANTY; without even the implied warranty of
Packit aea12f
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit aea12f
# General Public License for more details.
Packit aea12f
#
Packit aea12f
# You should have received a copy of the GNU General Public License
Packit aea12f
# along with GnuTLS; if not, write to the Free Software Foundation,
Packit aea12f
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
Packit aea12f
Packit aea12f
#set -e
Packit aea12f
Packit aea12f
srcdir="${srcdir:-.}"
Packit aea12f
CERTTOOL="${CERTTOOL:-../../src/certtool${EXEEXT}}"
Packit aea12f
DIFF="${DIFF:-diff}"
Packit aea12f
Packit aea12f
if ! test -x "${CERTTOOL}"; then
Packit aea12f
	exit 77
Packit aea12f
fi
Packit aea12f
Packit aea12f
export TZ="UTC"
Packit aea12f
TMPFILE=tmp-inhibit.pem.$$.tmp
Packit aea12f
TEMPLFILE=template.inhibit.$$.tmp
Packit aea12f
CAFILE=inhibit-ca.$$.tmp
Packit aea12f
SUBCAFILE=inhibit-subca.$$.tmp
Packit aea12f
Packit aea12f
. ${srcdir}/../scripts/common.sh
Packit aea12f
Packit aea12f
check_for_datefudge
Packit aea12f
Packit aea12f
datefudge -s "2017-04-22" \
Packit aea12f
	"${CERTTOOL}" --generate-self-signed \
Packit aea12f
		--load-privkey "${srcdir}/data/key-ca.pem" \
Packit aea12f
		--template "${srcdir}/templates/inhibit-anypolicy.tmpl" \
Packit aea12f
		--outfile ${CAFILE} 2>/dev/null
Packit aea12f
Packit aea12f
${DIFF} "${srcdir}/data/inhibit-anypolicy.pem" ${CAFILE}
Packit aea12f
rc=$?
Packit aea12f
Packit aea12f
# We're done.
Packit aea12f
if test "${rc}" != "0"; then
Packit aea12f
	echo "CA generation failed ${CAFILE}"
Packit aea12f
	exit ${rc}
Packit aea12f
fi
Packit aea12f
Packit aea12f
# generate leaf
Packit aea12f
echo ca > $TEMPLFILE
Packit aea12f
echo "cn = sub-CA" >> $TEMPLFILE
Packit aea12f
Packit aea12f
datefudge -s "2017-04-23" \
Packit aea12f
"${CERTTOOL}" -d 2 --generate-certificate --template $TEMPLFILE \
Packit aea12f
	--load-ca-privkey "${srcdir}/data/key-ca.pem" \
Packit aea12f
	--load-ca-certificate $CAFILE \
Packit aea12f
	--load-privkey "${srcdir}/data/key-subca.pem" \
Packit aea12f
	--outfile $SUBCAFILE
Packit aea12f
Packit aea12f
if [ $? != 0 ]; then
Packit aea12f
	cat $TMPFILE
Packit aea12f
	exit 1
Packit aea12f
fi
Packit aea12f
Packit aea12f
cat $SUBCAFILE $CAFILE > ${TMPFILE}
Packit aea12f
Packit aea12f
# we do not support the inhibit any policy extension for verification
Packit aea12f
datefudge -s "2017-04-25" "${CERTTOOL}" --verify-chain --infile ${TMPFILE}
Packit aea12f
rc=$?
Packit aea12f
if test "$rc" != "0"; then
Packit aea12f
	echo "Verification failed unexpectedly ($rc)"
Packit aea12f
	exit 1
Packit aea12f
fi
Packit aea12f
Packit aea12f
rm -f ${TMPFILE}
Packit aea12f
rm -f ${TEMPLFILE}
Packit aea12f
rm -f ${CAFILE}
Packit aea12f
rm -f ${SUBCAFILE}
Packit aea12f
Packit aea12f
exit 0